# SECURE-NICK.TCL secures nick from being stolen (hopefully)
# secure-nick - by:Ec|ipse
# Email: tomas@primenet.com    HTTP://www.primenet.com/~tomas
# All feeback, errors, questions and suggestions welcome :)

# By Ec|ipse@EFnet (tomas@primenet.com) (C) 1997.. All rights reserved and such..
#
# PLEASE: Don't reproduce this without my name on any unmodified code. Try to give
#         me some recogniton for anything borrowed out of this script

# idea    09-09-97  tomas@primenet.com    started

# INSTRUCTIONS:
#   - msg bot secure on <nick>
#     and the bot will hold the chosen nick till you msg bot secure off
#     
# KNOWN PROBLEMS:
#   - bot will revert to nick in config file if restarted

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
#    W A R N I N G    You don't need to change anything below here    W A R N I N G    #
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#

set holding ""
set keep-nick 0

bind msg n secure msg:secure
proc msg:secure {user host hand arg} {
  global nick holding
  set holding [lindex $arg 1]
  switch [lindex [string tolower $arg] 0] {
    "on" {
      if {[matchattr $hand n] == 1} {
        set holding [lindex $arg 1]
        putserv "NOTICE $user :*** Secure-Nick now \002Enabled\002"
        putcmdlog "#$hand# secure on"
        nick:secure
      } {
        putcmdlog "#$hand# secure on \[Failed\]"
      }
    }
    "off" {
      if {[matchattr $hand n] == 1} {
        unset holding
        putserv "NOTICE $user :*** Secure-Nick now \002Disabled\002"
        putcmdlog "#$hand# secure off"
        foreach timer [utimers] {
          if {[lindex $timer 1] == "*nick:secure*"} {killutimer [lindex $timer 2]}
        }
        putserv "NICK ${nick}"
      } {
        putcmdlog "#$hand# secure off \[Failed\]"
      }
    }
    "help" {
      putcmdlog "#$hand# secure help"
      putserv "NOTICE $user :\002Secure-Nick v1.0\002 by Ec|ipse <tomas@primenet.com>"
      putserv "NOTICE $user : "
      putserv "NOTICE $user :This script will secure a nick of your choice, till you msg"
      putserv "NOTICE $user :the bot to release it, at which point it reverts to its botnick"
      putserv "NOTICE $user : "
      putserv "NOTICE $user :  Usage: .secure \[on|off|help\] \[nick\]"
      putserv "NOTICE $user :    seen \002on\002 - will enable secure on chosen nick."
      putserv "NOTICE $user :    seen \002off\002 - will disable secure."
      putserv "NOTICE $user :    seen \002help\002 - displays what you are seeing now"
    }
    default {
      putcmdlog "#$hand# secure $arg"
      if {$secure_status == 1} {
        putserv "NOTICE $user :*** Secure-Nick is \002Enabled\002"
      } {
        putserv "NOTICE $user :*** Secure-Nick is \002Disabled\002"
      }
      putserv "NOTICE $user :  Usage: /msg <bot> secure \[on|off|help\] \[nick\]"
    }
  }
}

proc nick:secure {} {
  global botnick holding
  if {[string compare [string tolower ${botnick}] [string tolower ${holding}]] != 0} {
    putserv "WHOIS ${holding}"
  }
  utimer 30 nick:secure
}

bind raw - "401" 401:check
proc 401:check {from key raw} {
  global holding
  putserv "NICK ${holding}"
  foreach timer [utimers] {
    if {[lindex $timer 1] == "nick:secure"} {killutimer [lindex $timer 2]}
  }
}

foreach timer [utimers] {
  if {[lindex $timer 1] == "nick:secure"} {killutimer [lindex $timer 2]}
}

putlog "\"Secure-Nick v1.0\" by: Ec|ipse loaded..."
